/*
Copyright (C) 2006-2007 the DSQuake project.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#ifndef _ENDPOINT_H_
#define _ENDPOINT_H_

struct sockaddr;

enum EndPoint_Type 
{
	EPT_Unknown,
	EPT_UDP
};

class EndPoint
{
	protected:
		bool m_bValid;
	public:
		EndPoint();
		bool IsValid() const;
		virtual int BindSocketLocal(int in_Socket) const;
		virtual bool HasSockAddress(const sockaddr*in_RemoteAddress, const int in_AddrLen) const;
		virtual bool HasSameAddress(const EndPoint*in_EndPoint) const;
		virtual int SendDataWith(int in_Socket, const char*in_Buf, const int in_NumBuf) = 0;
		virtual void GetText(char*out_strText, const int in_BufLen) const = 0;
		virtual EndPoint*Clone() const = 0;
		virtual EndPoint_Type GetType() const;
};

#endif // _ENDPOINT_H_
