/*
Copyright (C) 2006-2007 the DSQuake project.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#ifndef _ENDPOINT_UDP_H_
#define _ENDPOINT_UDP_H_

#include "EndPoint.h"
#include <winsock2.h>

class EndPoint_UDP : public EndPoint
{
	private:
		sockaddr_in m_Address;
	public:
		void SetAddress(const sockaddr_in*in_Address);
		void SetAddress(const char*in_strAddress, const int in_DefaultPort);
		void SetLocalPort(const char*in_strPort);
		void SetLocalPort(const int in_Port = -1);
		void SetPort(const int in_Port);
		int  GetPort() const;
		virtual int BindSocketLocal(int in_Socket) const;
		virtual bool HasSockAddress(const sockaddr*in_RemoteAddress, const int in_AddrLen) const;
		virtual bool HasSameAddress(const EndPoint*in_EndPoint) const;
		virtual int SendDataWith(int in_Socket, const char*in_Buf, const int in_NumBuf);
		virtual void GetText(char*out_strText, const int in_BufLen) const;
		virtual EndPoint*Clone() const;
		virtual EndPoint_Type GetType() const;
};

#endif // _ENDPOINT_UDP_H_
