/*
Copyright (C) 2006-2007 the DSQuake project.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#ifndef _FORWARDEDLINK_H_
#define _FORWARDEDLINK_H_

#include "RemoteLink.h"

class ForwardedLink : public RemoteLink
{
	private:
		int       m_NumFwdBuffer;
		const int m_MaxFwdBuffer;
		char     *m_FwdBuffer;
	protected:
		unsigned int m_ForwardLANID;
		unsigned int m_ForwardLinkID;

	public:
		ForwardedLink(const char*in_Name, LinkSetBase*in_ParentLinkSet, unsigned int in_LinkID, const EndPoint*in_LocalEndPoint, EndPoint*in_RemoteEndPoint);
		void SetForwardingDestination(unsigned int in_LANID, unsigned int in_LinkID);
		virtual ~ForwardedLink();
		void ClearForwardData();
		void GetForwardData(char*&out_FwdData, int&out_NumFwdData);
		virtual void GetText(char*out_strText, const int in_BufLen) const;
		//virtual void SendForwardedData(char*in_FwdData, int in_NumFwdData);
		void ForwardData(const char*in_FwdBuf, const int in_NumFwdBuf);
};

#endif // _FORWARDEDLINK_H_
