/*
Copyright (C) 2006-2007 the DSQuake project.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#ifndef _LINKSETBASE_H_
#define _LINKSETBASE_H_

class EndPoint;
class ProxyBase;
class RemoteLink;

class LinkSetBase
{
	public:
		virtual int AddRemoteLinkTo(const EndPoint*in_RemoteEndPoint)=0;
		virtual RemoteLink*GetRemoteLinkByNum(int in_Num) const=0;
		virtual bool HasLocalEndPoint(const EndPoint*in_LocalEndPoint) const=0;
		virtual ProxyBase*GetParentProxy() const=0;
		virtual void Work()=0;
		virtual void GetText(char*out_strText, const int in_BufLen) const=0;
};

#endif // _LINKSETBASE_H_
