/*
Copyright (C) 2006-2007 the DSQuake project.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#ifndef _QUAKELINK_H_
#define _QUAKELINK_H_

#include "ForwardedLink.h"

class QuakeLink : public ForwardedLink
{
	private:
		void HexDisplay(const char*in_Buf, int in_Num);
		void ProcessReceivedData();
		void ProcessReceivedDataInternal(char*in_Buf, int&in_NumBuf, bool in_bPrintOnly);
		virtual int GetPacketLength( const char*in_Data, int in_NumData ); 
	public:
		QuakeLink(const char*in_Name, LinkSetBase*in_ParentLinkSet, unsigned int in_LinkID, const EndPoint*in_LocalEndPoint,EndPoint*in_RemoteEndPoint);
		virtual void Work();
		virtual void SendForwardedData(unsigned int in_SrcLANID, unsigned int in_SrcLinkID, unsigned int in_DstLANID, unsigned int in_DstLinkID, int in_ReplaceLocalPortAtOffset, const char*in_FwdBuf, int in_NumFwdBuf);
};

#endif // _QUAKELINK_H_
