/*
Copyright (C) 2006-2007 the DSQuake project.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#ifndef _SINGLELINK_H_
#define _SINGLELINK_H_

#include "LinkSet.h"

template<class RemoteLinkType>
class SingleLink : public LinkSet<RemoteLinkType>
{
	public:
		SingleLink(const char*in_Name, ProxyBase*in_ParentProxy, const EndPoint*in_LocalEndPoint, const EndPoint*in_RemoteEndPoint = NULL);
		virtual const char*GetTypeName() const;
};

template<class RemoteLinkType>
SingleLink<RemoteLinkType>::SingleLink(const char*in_Name, ProxyBase*in_ParentProxy, const EndPoint*in_LocalEndPoint, const EndPoint*in_RemoteEndPoint)
: LinkSet<RemoteLinkType>(in_Name, in_ParentProxy, in_LocalEndPoint, 1)
{
	if(in_RemoteEndPoint != NULL)
		this->AddRemoteLinkTo(in_RemoteEndPoint);
}

template<class RemoteLinkType>
const char*SingleLink<RemoteLinkType>::GetTypeName() const
{
	return "SingleLink";
}

#endif // _SINGLELINK_H_
